<?php
if ( !defined( 'ABSPATH' ) ) exit();

if ( ! class_exists('OVAM_Custom_Column') ) {
	

	class OVAM_Custom_Column {
		public function __construct(){
			add_filter( 'manage_ova-megamenu_posts_columns', array( $this, 'set_custom_edit_shortcode_columns' ) );
			add_action( 'manage_ova-megamenu_posts_custom_column' , array( $this, 'custom_shortcode_column' ), 10, 2 );
		}

		public function set_custom_edit_shortcode_columns( $columns ){
			$new_columns = array();
			if ( $columns ) {
				foreach ( $columns as $key => $value ) {
					if ( $key === 'author' ) {
						$new_columns['shortcode'] = esc_html__( 'Shortcode', 'ova-megamenu' );
					}
					$new_columns[$key] = $value;
				}
			}
			return $new_columns;
		}

		public function custom_shortcode_column( $column, $post_id ){
			switch ( $column ) {
				case 'shortcode':
					$shortcode = ova_megamenu_get_shortcode_by_id( $post_id );
					$output = "\n" . '<span class="shortcode"><input type="text"'
					. ' onfocus="this.select();" readonly="readonly"'
					. ' value="' . esc_attr( $shortcode ) . '"'
					. ' class="large-text code" /></span>';
					echo $output;
					break;
				
				default:
					break;
			}
		}
	}

	new OVAM_Custom_Column();
}

