<?php

if ( !defined( 'ABSPATH' ) ) exit();

if ( ! class_exists('OVAM_Menu_Custom_Field') ) {
	class OVAM_Menu_Custom_Field {

		public function __construct(){
			add_action( 'wp_nav_menu_item_custom_fields', [ $this, 'add_field' ], 10, 5 );
			add_action( 'wp_update_nav_menu_item', [ $this, 'save_field' ], 10, 2 );
		}

		public function add_field( $item_id, $menu_item, $depth, $args, $current_object_id ){
			if ( $depth > 0 || $menu_item->type != 'custom' ) {
				return;
			}
			wp_nonce_field( 'ova_megamenu_nonce', '_ova_megamenu_nonce_name' );
			$shortcode = get_post_meta( $item_id, '_menu_item_shortcode', true );
		?>
		<p class="field-subtitle_menu_meta description-wide">
			<label for="edit-menu-item-attr-shortcode-<?php echo $item_id; ?>">
				<?php esc_html_e( 'Megamenu Shortcode', 'ova-megamenu' ); ?><br />
				<input type="text" id="edit-menu-item-attr-shortcode-<?php echo $item_id; ?>" class="widefat edit-menu-item-attr-shortcode" name="menu-item-attr-shortcode[<?php echo $item_id; ?>]" value="<?php echo esc_attr( $shortcode ); ?>" />
			</label>
		</p>
		<?php
		}

		public function save_field( $menu_id, $menu_item_db_id ) {
			if ( ! array_key_exists( '_ova_megamenu_nonce_name', $_POST )
				|| ! wp_verify_nonce( $_POST['_ova_megamenu_nonce_name'], 'ova_megamenu_nonce' )
			) {
				return $menu_id;
			}
			$shortcode = $_POST['menu-item-attr-shortcode'][$menu_item_db_id] ?? null;
			if ( $shortcode ) {
				update_post_meta( $menu_item_db_id, '_menu_item_shortcode', sanitize_text_field( $shortcode ) );
			} else {
				delete_post_meta( $menu_item_db_id, '_menu_item_shortcode' );
			}
		}
	}

	new OVAM_Menu_Custom_Field();
}