(function($) {

	class OVAM_Admin {

		constructor() {
			// metabox
			this.ova_megamenu_menu_item_sortable();
			this.ova_megamenu_accordion();
			this.ova_megamenu_accordion_menu_item();
			this.ova_megamenu_add_row();
			this.ova_megamenu_add_column();
			this.ova_megamenu_remove_column();
			this.ova_megamenu_remove_row();
			this.ova_megamenu_select_widget();
			this.ova_megamenu_add_widget();
			this.ova_megamenu_remove_widget();
			this.ova_megamenu_select_menu();
			this.ova_megamenu_add_menu_item();
			this.ova_megamenu_add_page_item();
			this.ova_megamenu_remove_menu_item();
			this.ova_megamenu_menu_item_rename();
			this.ova_megamenu_check_all_item();
			this.ova_megamenu_filter_page();
			this.ova_megamenu_add_post_item();
			this.ova_megamenu_filter_post();
			this.ova_megamenu_add_custom_link();
			this.ova_megamenu_add_category_item();
			this.ova_megamenu_filter_categories();
			this.ova_megamenu_add_custom_tax_item();
			this.ova_megamenu_filter_custom_taxonomies();
			this.ova_megamenu_filter_custom_post_type();
			this.ova_megamenu_add_custom_post_item();
			this.ova_megamenu_tab_meta();
			this.ova_megamenu_menu_item_bulk_select();
			this.ova_megamenu_check_menu_item();
			this.ova_megamenu_menu_item_remove();
			this.ova_megamenu_column_resize();
			this.ova_megamenu_select_copy_data();
			this.ova_megamenu_copy_update();
			this.ova_megamenu_edit_width();
			// settings
			this.ova_megamenu_tab_settings();
			this.ova_megamenu_select2();
			this.ova_megamenu_codemirror();
			this.ova_megamenu_export_popup();
			this.ova_megamenu_import_popup();
			this.ova_megamenu_reset_settings();
			
		}

		ova_megamenu_edit_width(){
			$(document).on('click','.ova_megamenu_edit_width',function(){
				var $this = $(this);
				var this_column = $this.closest('.ova_megamenu_column');
				var column_width = this_column.find('.ova_megamenu_column_width');
				if ( column_width.hasClass('is-active') ) {
					column_width.removeClass('is-active');
				} else {
					column_width.addClass('is-active');
				}
			});

			$(document).on('change','.ova_megamenu_column_width',function(){
				var $this = $(this);
				var this_column = $this.closest('.ova_megamenu_column');
				var column_contain = this_column.closest('.ova_megamenu_columns');
				var columns = column_contain.find('.ova_megamenu_column').not(this_column);
				var $val = parseFloat( $this.val() );
				
				var total_percent = 0;

				columns.each( function(i,el){
					var percent = parseFloat( $(el).find('.ova_megamenu_column_width').val() );
					total_percent += percent;
				} );
				var $max = 100 - total_percent;

				if ( $val > $max ) {
					$val = $max;
				}
	
				$val = $val.toFixed(1);
				$this.val( $val );
				this_column.css('width',$val+'%');
				this_column.find('.show_column_percent').html( $val+'%' );
			});
		}

		ova_megamenu_copy_update(){
			var that = this;
			$('.ova_megamenu_copy_update').on('click',function(){
				var $this = $(this);
				var tab_content = $this.closest('.tabs-content');
				var copy_from = tab_content.find('.ova_megamenu_copy').val();
				var nonce = $this.attr('data-nonce');
				var tab = $this.attr('data-tab');
				var id = $this.attr('data-post-id');

				var data = {
					'action': 'ova_megamenu_copy_update',
					'nonce': nonce,
					'tab': tab,
					'copy_from': copy_from,
					'id': id,
				}

				$this.prop('disabled',true);
				$.post( ova_megamenu.ajax_url, data, function(res){
					tab_content.find('.ova_content_rows').html( res );
					$this.prop('disabled',false);

					if ( res != '' ) {
						that.ova_megamenu_menu_item_sortable();
						that.ova_megamenu_column_resize();
						tab_content.find('.ova-megamenu-copy-data').removeClass('is-active');
						tab_content.find('.ova_megamenu_btn_row').fadeIn();
					}
					
				} );
			});
		}

		ova_megamenu_reset_settings(){
			$('.ova_reset_settings').on('click',function(){
				var $this = $(this);
				var $title = $this.attr('data-title');
				var $button = $this.attr('data-button');
				var $desc = $this.attr('data-desc');
				var nonce = $this.attr('data-nonce');
				$button = JSON.parse( $button );
				new $.Zebra_Dialog(
				    $desc,
				    {
				        type: "question",
				        title: $title,
				        buttons: [
				            {caption: $button.yes, callback: function() {
				                var data = {
				                	'action': 'ova_megamenu_reset_settings',
				                	'nonce': nonce,
				                }
				                $.post( ova_megamenu.ajax_url, data, function(res){
				                	res = JSON.parse(res);
				    				if ( res.status == 'success' ) {
				    					new $.Zebra_Dialog(res.mess, {
					                        auto_close: 2000,
					                        buttons: false,
					                        modal: false,
					                        type: "confirmation"
					                    });
				    				} else {
				    					new $.Zebra_Dialog(res.mess, {
					                        auto_close: 2000,
					                        buttons: false,
					                        modal: false,
					                        type: "error"
					                    });
				    				}
				                } );
				            }},
				            {caption: $button.no},
				        ]
				    }
				);
			});
		}

		ova_megamenu_select_copy_data(){
			$(document).on('change','.ova_megamenu_copy',function(){
				var $val = $(this).val();
				var $tab_content = $(this).closest('.tabs-content');
				if ( $val != '' ) {
					$tab_content.find('.ova_megamenu_btn_row').fadeOut();
				} else {
					$tab_content.find('.ova_megamenu_btn_row').fadeIn();
				}

			});
		}

		ova_megamenu_import_popup(){
			if ( $('.ova-megamenu-tools').length ) {
				$('.ova_import_settings_popup').off().on('click',function(){
					var $this = $(this);
					var title = $this.attr('data-title');
					var nonce = $this.attr('data-nonce');
					var button = $this.attr('data-button');
					var data = {
						'action': 'ova_megamenu_import_popup',
					}

					$this.prop('disabled',true);

					$.post( ova_megamenu.ajax_url, data, function(html){
						new $.Zebra_Dialog(
						    html,
						    {
						    	type: false,
						    	title: title,
						    	buttons: [{
						    		caption: button,
						    		callback: function(){
						    			var content = $('.ova_import_content').val();
						    			content = content.trim();
						    			if ( isJsonString( content ) ) {
						    				content = JSON.parse( content );
						    			}
						    			var data = {
						    				'action': 'ova_megamenu_import_settings',
						    				'data': content,
						    				'nonce': nonce,
						    			}
						    			$.post( ova_megamenu.ajax_url, data, function(res){
						    				
						    				res = JSON.parse(res);
						    				if ( res.status == 'success' ) {
						    					new $.Zebra_Dialog(res.mess, {
							                        auto_close: 2000,
							                        buttons: false,
							                        modal: false,
							                        type: "confirmation"
							                    });
						    				} else {
						    					new $.Zebra_Dialog(res.mess, {
							                        auto_close: 2000,
							                        buttons: false,
							                        modal: false,
							                        type: "error"
							                    });
						    				}
						    				
						    			});
						    		}
						    	}],
						    	width: 320
						    }
						);
						$this.prop('disabled',false);

					} );

				});
			}

			function isJsonString(str) {
			    try {
			        JSON.parse(str);
			    } catch (e) {
			        return false;
			    }
			    return true;
			}

		}

		ova_megamenu_export_popup(){
			
			if ( $('.ova-megamenu-tools').length ) {
				$('.ova_export_settings_popup').off().on('click',function(){
					var $this = $(this);
					var title = $this.attr('data-title');
					var nonce = $this.attr('data-nonce');
					var data = {
						'action': 'ova_megamenu_export_settings',
						'nonce': nonce,
					}
					$this.prop('disabled',true);

					$.post( ova_megamenu.ajax_url, data, function(html){
						new $.Zebra_Dialog(
						    html,
						    {
						    	type: false,
						    	title: title,
						    	buttons: false,
						    	width: 320
						    }
						);
						$this.prop('disabled',false);
					} );

					
				});
			}
		}

		ova_megamenu_column_width( $tab, $row ){
			var $items = $(document).find('.tabs-content[data-tab="'+$tab+'"] .ova_megamenu_row[data-row="'+$row+'"] .ova_megamenu_column');
			var $count_item = $items.length;
			var $width = 100 / $count_item;
			var $total_percent = 100;
			$width = $width.toFixed(1);
			$items.each( function(i,el){
				$(el).css( 'width', $width+'%' );
				$(el).find('.show_column_percent').html( $width+'%' );
				$(el).find('.ova_megamenu_column_width').val( $width );
			} );
		}

		ova_megamenu_column_resize(){

			var $check_rtl = $('body').hasClass('rtl') ? 'left' : 'right';

			$('.ova_megamenu_column').resizable({
				handleSelector: '> .ova_megamenu_resize',
   				resizeHeight: false,
   				resizeWidthFrom: $check_rtl,
   				onDragStart: function (e, $el, opt) {
   					$el.find('.show_column_percent').addClass('is-active');
   					$el.find('.ova_megamenu_column_width').removeClass('is-active');
   				},
   				onDragEnd: function (e, $el, opt) {
			        $el.find('.show_column_percent').removeClass('is-active');
			    },
   				onDrag: function(e, $el, newWidth, newHeight, opt){
   					var $container = $el.closest('.ova_megamenu_columns');
   					var $rest_item = $container.find('.ova_megamenu_column').not( $el );
   					var $outerWidth = $container.width();
   					var $container_width = $outerWidth - 70;
   					var $total_percent = 0;

   					if ( newWidth > $outerWidth ) {
   						newWidth = $container_width;
   					}
   					var $width_percent = newWidth / $container_width * 100;
   					if ( $width_percent < 1 ) {
   						$width_percent = 1;
   					}
   					$width_percent = parseFloat( $width_percent.toFixed(1) );
   					$rest_item.find('.ova_megamenu_column_width').each( function(i,el){
   						$total_percent += parseFloat( $(el).val() );
   					} );

   					if ( $width_percent + $total_percent <= 100 ) {
   						$el.width( newWidth );
	   					$el.find('.ova_megamenu_column_width').val( $width_percent );
	   					$el.find('.show_column_percent').html( $width_percent +'%' );
   					} else {
   						$width_percent = 100 - $total_percent;
   						$width_percent = parseFloat( $width_percent.toFixed(1) );
   						$el.width( $width_percent + '%' );
	   					$el.find('.ova_megamenu_column_width').val( $width_percent );
	   					$el.find('.show_column_percent').html( $width_percent +'%' );
   					}

   					return false;
   				}
			});
		}

		ova_megamenu_menu_item_remove(){
			$(document).on('click','.ova_menu_item_remove',function(e){
				e.preventDefault();
				var $this = $(this);
				var menu_field = $this.closest('.ova_megamenu_sub_field');
				var check_menu_item = menu_field.find('.ova_check_menu_item:checked');

				check_menu_item.each( function(i,el){
					$(el).closest('.menu-item').remove();
				} );

				var rest_menu_item = menu_field.find('.menu-item');
				var menu_item_bulk_select = menu_field.find('.ova_megamenu_menu_item_bulk_select');
				var ova_menu_item_remove = menu_field.find('.ova_menu_item_remove');
				// reindex
				if ( rest_menu_item.length ) {
					rest_menu_item.each(function(i,el){
						var menu_item_field = $(el).find('[name^="ova_megamenu"]');
						menu_item_field.each(function(k,ele){
							let name = $(ele).attr('name');
							let pos_before = name.lastIndexOf('[menu_item]');
							let str_before = name.slice( 0, pos_before );
							let pos_after = name.lastIndexOf('[');
							let str_after = name.slice(pos_after);
							let new_name = str_before + '[menu_item]' + '['+ i + ']' + str_after;
							$(ele).attr('name', new_name);
						});
					});
				} else {
					menu_item_bulk_select.removeClass('is-active');
					menu_item_bulk_select.find('.menu_item_bulk_select:checked').prop('checked',false);
					ova_menu_item_remove.removeClass('is-active');
				}
				
			});
		}


		ova_megamenu_check_menu_item(){

			$(document).on('change','.ova_check_menu_item',function(){
				var $this = $(this);
				var menu_field = $this.closest('.ova_megamenu_sub_field');
				var check_menu_item = menu_field.find('.ova_check_menu_item:checked');
				var count_checked = check_menu_item.length;
				var ova_menu_item_remove = menu_field.find('.ova_menu_item_remove');
				if ( count_checked ) {
					ova_menu_item_remove.addClass('is-active');
				} else {
					ova_menu_item_remove.removeClass('is-active');
				}
			});

		}


		ova_megamenu_menu_item_bulk_select(){

			$(document).on('click','.ova_megamenu_menu_item_bulk_select',function(){
				var $this = $(this);
				var $this_field = $this.closest('.ova_megamenu_sub_field');
				var $buttons = $this_field.find('.ova_megamenu_menu_item_bulk_select');
				var ova_menu_item_remove = $this_field.find('.ova_menu_item_remove');
				var check_menu_item = $this_field.find('.ova_check_menu_item:checked');
				if ( ! $this.hasClass('is-checked') ) {
					$this_field.find('.menu_item_bulk_select').prop('checked',true);
					$buttons.addClass('is-checked');
					$this_field.find('.ova_check_menu_item').fadeIn();
				} else {
					$this_field.find('.menu_item_bulk_select').prop('checked',false);
					$buttons.removeClass('is-checked');
					$this_field.find('.ova_check_menu_item').fadeOut();
					check_menu_item.prop('checked',false);
					ova_menu_item_remove.removeClass('is-active');
				}
			});

		}

		ova_megamenu_codemirror(){

			if (typeof wp.codeEditor !== 'undefined' && typeof cm_settings !== 'undefined') {
		        if ($('#code_editor').length) {
		            wp.codeEditor.initialize($('#code_editor'), cm_settings);
		        }

		        $('.nav-tab').on('click', function() {
		            setTimeout( function() {
		                $('.tabs-content').find('.CodeMirror').each(function(key, value) {
		                    value.CodeMirror.refresh();
		                });
		            }, 160);
		        });
		    }
		}

		ova_megamenu_select2(){
			

			if ( $('.ova-megamenu-wrap').length ) {
				var select_font = $('.select_font').select2();

				select_font.each( function(i,el){
					var font = $(el).val();

					var this_item = $(el).closest('.ova-list');
					var select_font_weight = this_item.find('.select_font_weight');
					var font_weight = select_font_weight.attr('data-value');
					var nonce = $(el).attr('data-nonce');
					var data = {
						'action': 'ova_megamenu_select_font',
						'nonce': nonce,
						'font': font,
						'font_weight': font_weight,
					}
					$.post( ova_megamenu.ajax_url, data, function(res){
						select_font_weight.html('');
						select_font_weight.html(res);
					} );
				} );

				select_font.on('change',function(e){
					var font = $(this).val();
					var this_item = $(this).closest('.ova-list');
					var select_font_weight = this_item.find('.select_font_weight');
					var font_weight = select_font_weight.val();
					var nonce = $(this).attr('data-nonce');
					var data = {
						'action': 'ova_megamenu_select_font',
						'nonce': nonce,
						'font': font,
						'font_weight': font_weight,
					}
					$.post( ova_megamenu.ajax_url, data, function(res){
						select_font_weight.html('');
						select_font_weight.html(res);
					} );
				});
			}
		}

		ova_megamenu_tab_settings(){
			/* Settings */
			if ( $('.ova-megamenu-wrap').length ) {
				var $hash = ''; 
				if ( window.location.hash ) {
					$hash = window.location.hash;
				}
				var $id = 'general';

				if ( $hash != '' ) {
					$id = $hash.replace('#','');
					$('.ova_megamenu_settings_form').attr('action','options.php'+'#'+$id);
				}

				$('.ova-megamenu-wrap .nav-tab-wrapper a'+'[data-id="'+$id+'"]').addClass('nav-tab-active');
				$('#'+$id).addClass('tab-active');

				$('.ova-megamenu-wrap .nav-tab-wrapper a').on('click',function(){
					var $id = $(this).attr('data-id');

					setTimeout( function() {
		                $('.ova-megamenu-wrap').find('.CodeMirror').each(function(key, value) {
		                    value.CodeMirror.refresh();
		                });
		            }, 160);

					$('.ova-megamenu-wrap .nav-tab').removeClass('nav-tab-active');
					$('.ova-megamenu-wrap .tabs-content').removeClass('tab-active');

					$(this).addClass('nav-tab-active');
					$('#'+$id).addClass('tab-active');
					$('.ova_megamenu_settings_form').attr('action','options.php'+'#'+$id);
				});
			}
			/* Tools */
			if ( $('.ova-megamenu-tools').length ) {
				var $hash = ''; 
				if ( window.location.hash ) {
					$hash = window.location.hash;
				}
				var $id = 'general';

				if ( $hash != '' ) {
					$id = $hash.replace('#','');
				}

				$('.ova-megamenu-tools .nav-tab-wrapper a'+'[data-id="'+$id+'"]').addClass('nav-tab-active');
				$('#'+$id).addClass('tab-active');

				$('.ova-megamenu-tools .nav-tab-wrapper a').on('click',function(){
					var $id = $(this).attr('data-id');

					$('.ova-megamenu-tools .nav-tab').removeClass('nav-tab-active');
					$('.ova-megamenu-tools .tabs-content').removeClass('tab-active');

					$(this).addClass('nav-tab-active');
					$('#'+$id).addClass('tab-active');
				});
			}

		}

		ova_megamenu_tab_meta(){
			if ( $('#ova_megamenu_metabox_container').length ) {

				var $hash = ''; 
				if ( window.location.hash ) {
					$hash = window.location.hash;
				}
				var $id = 'ova_megamenu_desktop';

				if ( $hash != '' ) {
					$id = $hash.replace('#','');
					$('#post').attr('action','post.php'+'#'+$id);
				}

				$('#ova_megamenu_metabox_container .nav-tab-wrapper a'+'[data-id='+$id+']').addClass('nav-tab-active');
				$('#'+$id).addClass('tab-active');

				$('#ova_megamenu_metabox_container .nav-tab-wrapper a').on('click',function(){
					var $id = $(this).attr('data-id');

					$('#ova_megamenu_metabox_container .nav-tab').removeClass('nav-tab-active');
					$('#ova_megamenu_metabox_container .tabs-content').removeClass('tab-active');

					$(this).addClass('nav-tab-active');
					$('#'+$id).addClass('tab-active');
					$('#post').attr('action','post.php'+'#'+$id);
				});
			}
		}

		ova_megamenu_menu_item_sortable(){

			if ( $('#ova_megamenu_metabox_container').length ) {
				$('#ova_megamenu_metabox_container .list-menu-item').sortable({
					handle: '.menu-title',
					placeholder: "ui-state-highlight",
					stop: function( event, ui ) {
						const item = $(ui.item);
						const items = item.closest('.list-menu-item').find('.menu-item');

						items.each( function(i_item,el_item){
							const elements = $(el_item).find('input[name^="ova_megamenu"]');

							elements.each( function(i,el){
								let name = $(el).attr('name');
								let pos_menu_item = name.indexOf('[menu_item]');
								let start_str = name.slice(0,pos_menu_item);
								let pos_rest = name.lastIndexOf('['); 
								let end_str = name.slice(pos_rest);
								let new_name = start_str+'[menu_item]'+'['+i_item+']'+end_str;
								$(el).attr('name',new_name);
							} );

						} );
					}
				});
				$('#ova_megamenu_metabox_container .list-menu-item').disableSelection();
			}
			
		}

		ova_megamenu_accordion(){

			$(document).on('click','.ova_megamenu_accordion .heading',function(e){
				e.preventDefault();
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				
				if ( ! this_item.hasClass('active') ) {
					$(this).closest('.ova_megamenu_accordion_item').addClass('active');
					$(this).closest('.ova_megamenu_accordion_item').find('.content').slideDown();
				} else {
					$(this).closest('.ova_megamenu_accordion_item').removeClass('active');
					$(this).closest('.ova_megamenu_accordion_item').find('.content').slideUp();
				}
				
			});

		}

		ova_megamenu_accordion_menu_item(){

			$(document).on('click','.ova_megamenu_sub_field .menu-title .icon',function(e){
				var this_item = $(this).closest('.menu-item');
				var icon = $(this).find('.dashicons');
				if ( ! this_item.hasClass('active') ) {
					$(this).closest('.menu-item').addClass('active');
					$(this).closest('.menu-item').find('.content').slideDown();
					icon.removeClass('dashicons-arrow-down');
					icon.addClass('dashicons-arrow-up');
				} else {
					$(this).closest('.menu-item').removeClass('active');
					$(this).closest('.menu-item').find('.content').slideUp();
					icon.removeClass('dashicons-arrow-up');
					icon.addClass('dashicons-arrow-down');
				}
			});

			$(document).on('click','.ova_megamenu_cancel_menu_item',function(e){
				e.preventDefault();
				var this_item = $(this).closest('.menu-item');
				var icon = this_item.find('.dashicons');
				this_item.removeClass('active');
				this_item.find('.content').slideUp();
				icon.removeClass('dashicons-arrow-up');
				icon.addClass('dashicons-arrow-down');
			});
		}

		ova_megamenu_add_row(){
			var that = this;
			$(document).on('click','#ova_megamenu_add_row',function(e){
				e.preventDefault();
				let $nonce = $(document).find('#ova_megamenu_metabox_container').attr('data-nonce');
				var count_row = $(this).closest('.tabs-content').find('.ova_content_rows .ova_megamenu_row').length;
				var this_tab = $(this).closest('.tabs-content').attr('data-tab');
				var data = {
					'action': 'ova_megamenu_add_row',
					'nonce': $nonce,
					'row': count_row,
					'this_tab': this_tab,
				};
				var $this = $(this);
				$this.attr("disabled", true);
				$this.closest('.tabs-content').find('.ova_content_rows').addClass('loading');
				$this.closest('.tabs-content').find('.spinner_add_row').addClass('is-active');

				$.post(ova_megamenu.ajax_url, data, function(response) {
					$this.closest('.tabs-content').find('.ova_content_rows').append( response );
					$this.attr("disabled", false);
					$this.closest('.tabs-content').find('.ova_content_rows').removeClass('loading');
					$this.closest('.tabs-content').find('.spinner_add_row').removeClass('is-active');
					$this.closest('.tabs-content').find('.ova-megamenu-copy-data').removeClass('is-active');

					that.ova_megamenu_menu_item_sortable();
					that.ova_megamenu_column_resize();
				});
			});
		}

		ova_megamenu_remove_row(){
			$(document).on('click','.ova_megamenu_remove_row',function(e){
				e.preventDefault();
				var that_row = $(this).closest('.ova_megamenu_row');
				var tab = $(this).closest('.tabs-content');
				var this_tab = $(this).closest('.tabs-content').attr('data-tab');
				that_row.remove();
				// reindex
				var rows = $(document).find('.tabs-content[data-tab="'+this_tab+'"] .ova_content_rows .ova_megamenu_row');

				if ( rows.length ) {
					rows.each( function(i_row,el_row){
						$(el_row).attr('data-row', i_row);
						let elements = $(el_row).find('[name^="ova_megamenu_'+this_tab+'"]');
						elements.each( function(i,el){
							let name = $(el).attr('name');
							let end_point = name.indexOf(']');
							let end_str = name.slice( end_point + 1 );
							let new_name = 'ova_megamenu_'+this_tab+'['+i_row+']'+end_str;
							$(el).attr('name',new_name);
						} );
					} );
				} else {
					tab.find('.ova-megamenu-copy-data').addClass('is-active');
				}
				
			});
		}

		ova_megamenu_add_column(){
			var that = this;
			$(document).on('click','.ova_megamenu_add_column',function(e){
				e.preventDefault();
				let $nonce = $(document).find('#ova_megamenu_metabox_container').attr('data-nonce');
				var that_row = $(this).closest('.ova_megamenu_row');
				var count_column = that_row.find('.ova_megamenu_columns .ova_megamenu_column').length;
				var count_row = $(this).closest('.ova_megamenu_row').attr('data-row');
				var this_tab = $(this).closest('.tabs-content').attr('data-tab');
				var $this = $(this);
				var tab_content = $(this).closest('.tabs-content');
				var data = {
					'action': 'ova_megamenu_add_column',
					'nonce': $nonce,
					'column': count_column,
					'row': parseInt( count_row ),
					'this_tab': this_tab,
				};

				tab_content.find('.ova_content_rows').addClass('loading');
				$.post(ova_megamenu.ajax_url, data, function(response) {
					that_row.find('.ova_megamenu_columns').append( response );

					tab_content.find('.ova_content_rows').removeClass('loading');

					that.ova_megamenu_menu_item_sortable();
					that.ova_megamenu_column_resize();
					that.ova_megamenu_column_width( this_tab, count_row );
				});
			});
		}

		ova_megamenu_remove_column(){
			var that = this;
			$(document).on('click','.ova_megamenu_remove_column',function(e){
				e.preventDefault();
				var that_column = $(this).closest('.ova_megamenu_column');
				var that_row = $(this).closest('.ova_megamenu_row');
				var row = that_row.attr('data-row');
				var this_tab = $(this).closest('.tabs-content').attr('data-tab');
				that_column.remove();
				// reindex
				var columns = that_row.find('.ova_megamenu_column');
				
				columns.each( function(i_col,el_col){
					let elements = $(el_col).find('[name^="ova_megamenu_'+this_tab+'['+row+']"]');
					$(el_col).attr('data-column',i_col);
					elements.each( function(i,el){

						let name = $(el).attr('name');

						if ( name.indexOf('[widget]') == -1 ) {
							let end_point = name.lastIndexOf('[');
							let end_str = name.slice(end_point);
							let new_name = 'ova_megamenu_'+this_tab+'['+row+']['+i_col+']'+end_str;
							$(el).attr('name',new_name);
						} else {
							let end_point = name.indexOf('[widget]');
							let end_str = name.slice(end_point);
							let new_name = 'ova_megamenu_'+this_tab+'['+row+']['+i_col+']'+end_str;
							$(el).attr('name',new_name);
						}
						
					} );
				} );

				that.ova_megamenu_column_width( this_tab, row );

			});
		}

		ova_megamenu_select_widget(){
			var that = this;
			$(document).on('change','.ova_megamenu_widget',function(){
				$(this).closest('.ova_megamenu_widget_item').find('.ova_megamenu_field').fadeOut();
				$(this).closest('.ova_megamenu_widget_item').find('.ova_megamenu_sub_field').fadeOut();

				var data_id = $(this).find(":selected").val();

				if ( data_id ) {
					$(this).closest('.ova_megamenu_widget_item').find('tr[data-id="'+data_id+'"]').fadeIn();
					$(this).closest('.ova_megamenu_widget_item').find('tr[data-id="title"]').fadeIn();

					if ( data_id == 'menu' ) {
						that.ova_megamenu_show_menu_subfield( this );
					}
					
				}
			});
		}

		ova_megamenu_add_widget(){
			var that = this;
			$(document).on('click','.ova_megamenu_add_widget',function(e){
				e.preventDefault();

				let $nonce = $(document).find('#ova_megamenu_metabox_container').attr('data-nonce');
				var widgets = $(this).closest('.ova_megamenu_column').find('.ova_megamenu_widgets');
				var count_column = $(this).closest('.ova_megamenu_column').attr('data-column');
				var count_row = $(this).closest('.ova_megamenu_row').attr('data-row');
				var count_widget = widgets.find('.ova_megamenu_widget_item').length;
				var $this = $(this);
				var that_column = $this.closest('.ova_megamenu_columns');
				var this_tab = $this.closest('.tabs-content').attr('data-tab');
				var tab_content = $this.closest('.tabs-content');
				var data = {
					'action': 'ova_megamenu_add_widget',
					'nonce': $nonce,
					'row': parseInt( count_row ),
					'column': parseInt( count_column ),
					'widget': count_widget,
					'this_tab': this_tab,
				};


				$this.attr("disabled", true);
				tab_content.find('.ova_content_rows').addClass('loading');
				$.post(ova_megamenu.ajax_url, data, function(response) {
					widgets.append(response);
					that.ova_megamenu_menu_item_sortable();
					$this.attr("disabled", false);
					tab_content.find('.ova_content_rows').removeClass('loading');
				});

			});
		}

		ova_megamenu_remove_widget(){
			$(document).on('click','.ova_megamenu_remove_widget',function(e){
				e.preventDefault();
				var that_widget = $(this).closest('.ova_megamenu_widget_item');
				var that_column = $(this).closest('.ova_megamenu_column');
				var this_tab = $(this).closest('.tabs-content').attr('data-tab');
				that_widget.remove();
				// reindex
				var widgets = that_column.find('.ova_megamenu_widget_item');
				widgets.each( function(i_wid,el_wid){
					let elements = $(el_wid).find('[name^="ova_megamenu_'+this_tab+'"]');
					elements.each( function(i,el){
						let name = $(el).attr('name');
						let pos_menu_item = name.indexOf('[menu_item]');
						let pos_str_handle = name.indexOf('[widget]');

						// check menu item
						if ( pos_menu_item == -1 ) {
							let rest_str = name.slice(0,pos_str_handle);
							let str_handle = name.slice(pos_str_handle);
							let end_point = str_handle.lastIndexOf('[');
							let need_str = str_handle.slice( end_point );
							let new_str = '[widget]'+'['+i_wid+']'+need_str;
							let new_name = rest_str + new_str;
							$(el).attr('name',new_name);
						} else {
							let rest_str_menu_item = name.slice(pos_menu_item);
							let rest_str = name.slice(0,pos_str_handle);
							let str_handle = name.slice(pos_str_handle);
							let new_str = '[widget]'+'['+i_wid+']'+rest_str_menu_item;
							let new_name = rest_str + new_str;
							$(el).attr('name',new_name);
						}
						
					} );
				} );

			});
		}

		ova_megamenu_select_menu(){
			$(document).on('change','.menu_type',function(){
				$(this).closest('.ova_megamenu_widget_item').find('.ova_megamenu_sub_field').fadeOut();
				var data_id = $(this).val();
				if ( data_id ) {
					$(this).closest('.ova_megamenu_widget_item').find('tr[data-id="'+data_id+'"]').fadeIn();
				}
			});
		}

		ova_megamenu_show_menu_subfield( that ){
			var menu_type = $(that).closest('.ova_megamenu_widget_item').find('.menu_type:checked');

			menu_type.each( function(i,el){

				var data_id = $(el).val();
				if ( data_id ) {
					$(el).closest('.ova_megamenu_widget_item').find('tr[data-id="'+data_id+'"]').fadeIn();
				}
				
			} );
		}

		ova_megamenu_add_menu_item(){
			var that = this;
			$(document).on('click','.ova_megamenu_add_menu_item',function(e){
				e.preventDefault();
				var $title = $(this).attr('data-title');
				var $button = $(this).attr('data-btn');
				var this_item = $(this).closest('.ova_megamenu_widget_item');
				var row = this_item.attr('data-row');
				var column = this_item.attr('data-column');
				var widget = this_item.attr('data-widget');
				var menu_item = this_item.find('.menu-item').length;
				var this_tab = $(this).closest('.tabs-content').attr('data-tab');
				var bulk_select = this_item.find('.ova_megamenu_menu_item_bulk_select');
				var menu_item_remove = this_item.find('.ova_menu_item_remove');
				var check_menu_item = this_item.find('.ova_check_menu_item');
				let options = {
					type: false,
					source: {
				        inline: $(".ova_megamenu_dialog_box").html()
				    },
				    buttons: [$button],
					title: $title,
				    width: 400,
				    height: 800,
				};
				$.Zebra_Dialog(options);
				$(document).find('.ova_megamenu_add_to_menu').attr('data-tab',this_tab);	
				$(document).find('.ova_megamenu_add_to_menu').attr('data-row',row);		
				$(document).find('.ova_megamenu_add_to_menu').attr('data-column',column);		
				$(document).find('.ova_megamenu_add_to_menu').attr('data-widget',widget);	
				$(document).find('.ova_megamenu_add_to_menu').attr('data-menu-item',menu_item);

				bulk_select.find('.menu_item_bulk_select').prop('checked',false);
				menu_item_remove.removeClass('is-active');
				check_menu_item.prop('checked',false);
				check_menu_item.fadeOut();
			});
		}

		ova_megamenu_add_page_item(){
			$(document).on('click','.ova_megamenu_add_page_item',function(e){
				e.preventDefault();
				var inputs = $(document).find('.ova_megamenu_accordion .list-page input[type="checkbox"]:checked');
				var page_ids = [];
				var row = $(this).attr('data-row');
				var column = $(this).attr('data-column');
				var widget = $(this).attr('data-widget');
				var menu_item = $(this).attr('data-menu-item');
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var this_tab = $(this).attr('data-tab');
				inputs.each(function(i,el){
					let page_id = $(el).val();
					page_ids.push( page_id );
					$(el).prop( "checked", false );
				});
				this_item.find('.check_all_item').prop( "checked", false );
				var data = {
					'action': 'ova_megamenu_add_page_item',
					'page_ids': page_ids,
					'row': row,
					'column': column,
					'widget': widget,
					'menu_item': menu_item,
					'this_tab': this_tab,
				};

				$.post(ova_megamenu.ajax_url,data,function(res){
					var that_item = $(document).find('.tabs-content[data-tab="'+this_tab+'"] .ova_megamenu_widget_item[data-row="'+row+'"][data-column="'+column+'"][data-widget="'+widget+'"]');
					that_item.find('.list-menu-item').append(res);
					var count_menu_item = that_item.find('.list-menu-item .menu-item').length;
					that_item.find('.ova_megamenu_add_menu_item').attr('data-menu-item',count_menu_item);
					$(document).find('.ova_megamenu_add_to_menu').attr('data-menu-item',count_menu_item);
					if ( count_menu_item ) {
						that_item.find('.ova_megamenu_menu_item_bulk_select').addClass('is-active');
					} else {
						that_item.find('.ova_megamenu_menu_item_bulk_select').removeClass('is-active');
					}
				});
			});
		}

		ova_megamenu_remove_menu_item(){
			$(document).on('click','.ova_megamenu_remove_menu_item',function(e){
				e.preventDefault();
				var this_item = $(this).closest('.menu-item');
				var list_item = $(this).closest('.list-menu-item');
				var this_tab = $(this).closest('.tabs-content').attr('data-tab');
				this_item.remove();

				var menu_item = list_item.find('.menu-item');
				var menu_field = list_item.closest('.ova_megamenu_sub_field');
				// reindex
				var ova_megamenu_menu_item_bulk_select = menu_field.find('.ova_megamenu_menu_item_bulk_select');
				var ova_menu_item_remove = menu_field.find('.ova_menu_item_remove');

				if ( menu_item.length ) {
					menu_item.each( function(i_item,el_item){
						
						var inputs = $(el_item).find('input[name^="ova_megamenu_'+this_tab+'"]');

						inputs.each( function(i,el){
							let name = $(el).attr('name');
							let pos_menu_item = name.indexOf('[menu_item]');
							let pos_index = name.lastIndexOf('[');
							let str_before = name.slice(0,pos_menu_item);
							let str_after = name.slice(pos_index);
							let new_name = str_before+'[menu_item]'+'['+i_item+']'+str_after;
							$(el).attr('name',new_name);
						} );

					} );

				} else {
					ova_megamenu_menu_item_bulk_select.removeClass('is-active');
					ova_megamenu_menu_item_bulk_select.find('.menu_item_bulk_select:checked').prop('checked',false);
					ova_menu_item_remove.removeClass('is-active');
				}

			} );
		}

		ova_megamenu_menu_item_rename(){
			$(document).on('change','.ova_megamenu_widget_item .menu_item_title',function(){
				var title = $(this).val();
				var this_item = $(this).closest('.menu-item');
				var this_title = this_item.find('.menu-title .title');
				this_title.text(title);
			});
		}

		ova_megamenu_check_all_item(){
			$(document).on('change','.ova_megamenu_accordion .check_all_item',function(e){
				e.preventDefault();
				var is_checked = $(this).is(":checked");
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var menu_item = this_item.find('input[type="checkbox"]');
				if ( is_checked ) {
					menu_item.each( function(i,el){
						$(el).prop('checked', true);
					} );
				} else {
					menu_item.each( function(i,el){
						$(el).prop('checked', false);
					} );
				}
			});
		}

		ova_megamenu_filter_page(){
			var that = this;
			$(document).on('change','.ova_megamenu_accordion_item input.filter_page',function(){
				var page_title = $(this).val();
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var data = {
					'action': 'ova_megamenu_filter_page',
					'title': page_title,
				};
				$.post(ova_megamenu.ajax_url,data,function(res){
					this_item.find('.list-page').html('');
					this_item.find('.list-page').html(res);
				});
			});
		}

		ova_megamenu_add_post_item(){
			$(document).on('click','.ova_megamenu_add_post_item',function(e){
				e.preventDefault();
				var inputs = $(document).find('.ova_megamenu_accordion .list-post input[type="checkbox"]:checked');
				var post_ids = [];
				var row = $(this).attr('data-row');
				var column = $(this).attr('data-column');
				var widget = $(this).attr('data-widget');
				var menu_item = $(this).attr('data-menu-item');
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var this_tab = $(this).attr('data-tab');
				inputs.each(function(i,el){
					let post_id = $(el).val();
					post_ids.push( post_id );
					$(el).prop( "checked", false );
				});
				this_item.find('.check_all_item').prop( "checked", false );
				var data = {
					'action': 'ova_megamenu_add_post_item',
					'post_ids': post_ids,
					'row': row,
					'column': column,
					'widget': widget,
					'menu_item': menu_item,
					'this_tab': this_tab,
				};

				$.post(ova_megamenu.ajax_url,data,function(res){
					var that_item = $(document).find('.tabs-content[data-tab="'+this_tab+'"] .ova_megamenu_widget_item[data-row="'+row+'"][data-column="'+column+'"][data-widget="'+widget+'"]');
					that_item.find('.list-menu-item').append(res);
					var count_menu_item = that_item.find('.list-menu-item .menu-item').length;
					that_item.find('.ova_megamenu_add_menu_item').attr('data-menu-item',count_menu_item);
					$(document).find('.ova_megamenu_add_to_menu').attr('data-menu-item',count_menu_item);
					if ( count_menu_item ) {
						that_item.find('.ova_megamenu_menu_item_bulk_select').addClass('is-active');
					} else {
						that_item.find('.ova_megamenu_menu_item_bulk_select').removeClass('is-active');
					}
				});
			});
		}

		ova_megamenu_filter_post(){
			var that = this;
			$(document).on('change','.ova_megamenu_accordion_item input.filter_post',function(){
				var post_title = $(this).val();
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var data = {
					'action': 'ova_megamenu_filter_post',
					'title': post_title,
				};
				$.post(ova_megamenu.ajax_url,data,function(res){
					this_item.find('.list-post').html('');
					this_item.find('.list-post').html(res);
				});
			});
		}

		ova_megamenu_add_custom_link(){
			$(document).on('click','.ova_megamenu_add_custom_link',function(e){
				e.preventDefault();
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var url = this_item.find('input.url_item').val();
				var link_text = this_item.find('input.link_text_item').val();
				var row = $(this).attr('data-row');
				var column = $(this).attr('data-column');
				var widget = $(this).attr('data-widget');
				var menu_item = $(this).attr('data-menu-item');
				var this_tab = $(this).attr('data-tab');

				if ( url == '' ) {
					this_item.find('input.url_item').addClass('invalid');
				} else {
					this_item.find('input.url_item').removeClass('invalid');
				}

				if ( link_text == '' ) {
					this_item.find('input.link_text_item').addClass('invalid');
				} else {
					this_item.find('input.link_text_item').removeClass('invalid');
				}

				if ( url != '' && link_text != '' ) {
					var data = {
						'action': 'ova_megamenu_add_custom_link',
						'url': url,
						'link_text': link_text,
						'row': row,
						'column': column,
						'widget': widget,
						'menu_item': menu_item,
						'this_tab': this_tab,
					};
					$.post(ova_megamenu.ajax_url,data,function(res){
						var that_item = $(document).find('.tabs-content[data-tab="'+this_tab+'"] .ova_megamenu_widget_item[data-row="'+row+'"][data-column="'+column+'"][data-widget="'+widget+'"]');
						that_item.find('.list-menu-item').append(res);
						this_item.find('input.url_item').val('');
						this_item.find('input.link_text_item').val('');
						var count_menu_item = that_item.find('.list-menu-item .menu-item').length;
						that_item.find('.ova_megamenu_add_menu_item').attr('data-menu-item',count_menu_item);
						$(document).find('.ova_megamenu_add_to_menu').attr('data-menu-item',count_menu_item);
						if ( count_menu_item ) {
							that_item.find('.ova_megamenu_menu_item_bulk_select').addClass('is-active');
						} else {
							that_item.find('.ova_megamenu_menu_item_bulk_select').removeClass('is-active');
						}
					});
				}
			});
		}

		ova_megamenu_add_category_item(){
			$(document).on('click','.ova_megamenu_add_category_item',function(e){
				e.preventDefault();
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var inputs = this_item.find('.list-item input[type="checkbox"]:checked');
				var category_ids = [];
				var row = $(this).attr('data-row');
				var column = $(this).attr('data-column');
				var widget = $(this).attr('data-widget');
				var menu_item = $(this).attr('data-menu-item');
				var this_tab = $(this).attr('data-tab');

				inputs.each(function(i,el){
					let category_id = $(el).val();
					category_ids.push( category_id );
					$(el).prop( "checked", false );
				});
				this_item.find('.check_all_item').prop( "checked", false );
				var data = {
					'action': 'ova_megamenu_add_category_item',
					'category_ids': category_ids,
					'row': row,
					'column': column,
					'widget': widget,
					'menu_item': menu_item,
					'this_tab': this_tab,
				};

				$.post(ova_megamenu.ajax_url,data,function(res){
					var that_item = $(document).find('.tabs-content[data-tab="'+this_tab+'"] .ova_megamenu_widget_item[data-row="'+row+'"][data-column="'+column+'"][data-widget="'+widget+'"]');
					that_item.find('.list-menu-item').append(res);
					var count_menu_item = that_item.find('.list-menu-item .menu-item').length;
					that_item.find('.ova_megamenu_add_menu_item').attr('data-menu-item',count_menu_item);
					$(document).find('.ova_megamenu_add_to_menu').attr('data-menu-item',count_menu_item);
					if ( count_menu_item ) {
						that_item.find('.ova_megamenu_menu_item_bulk_select').addClass('is-active');
					} else {
						that_item.find('.ova_megamenu_menu_item_bulk_select').removeClass('is-active');
					}
				});
			});
		}

		ova_megamenu_filter_categories(){
			var that = this;
			$(document).on('change','.ova_megamenu_accordion_item input.filter_categories',function(){
				var name = $(this).val();
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var data = {
					'action': 'ova_megamenu_filter_categories',
					'name': name,
				};
				$.post(ova_megamenu.ajax_url,data,function(res){
					this_item.find('.list-category').html('');
					this_item.find('.list-category').html(res);
				});
			});
		}

		ova_megamenu_add_custom_tax_item(){
			$(document).on('click','.ova_megamenu_add_custom_tax_item',function(e){
				e.preventDefault();
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var inputs = this_item.find('.list-item input[type="checkbox"]:checked');
				var term_ids = [];
				var row = $(this).attr('data-row');
				var column = $(this).attr('data-column');
				var widget = $(this).attr('data-widget');
				var menu_item = $(this).attr('data-menu-item');
				var this_tab = $(this).attr('data-tab');

				inputs.each(function(i,el){
					let term_id = $(el).val();
					term_ids.push( term_id );
					$(el).prop( "checked", false );
				});
				this_item.find('.check_all_item').prop( "checked", false );
				var data = {
					'action': 'ova_megamenu_add_custom_tax_item',
					'term_ids': term_ids,
					'row': row,
					'column': column,
					'widget': widget,
					'menu_item': menu_item,
					'this_tab': this_tab,
				};
				$.post(ova_megamenu.ajax_url,data,function(res){
					var that_item = $(document).find('.tabs-content[data-tab="'+this_tab+'"] .ova_megamenu_widget_item[data-row="'+row+'"][data-column="'+column+'"][data-widget="'+widget+'"]');
					that_item.find('.list-menu-item').append(res);
					var count_menu_item = that_item.find('.list-menu-item .menu-item').length;
					that_item.find('.ova_megamenu_add_menu_item').attr('data-menu-item',count_menu_item);
					$(document).find('.ova_megamenu_add_to_menu').attr('data-menu-item',count_menu_item);
					if ( count_menu_item ) {
						that_item.find('.ova_megamenu_menu_item_bulk_select').addClass('is-active');
					} else {
						that_item.find('.ova_megamenu_menu_item_bulk_select').removeClass('is-active');
					}
				});
			});
		}

		ova_megamenu_filter_custom_taxonomies(){
			var that = this;
			$(document).on('change','.ova_megamenu_accordion_item input.filter_custom_taxonomies',function(){
				var name = $(this).val();
				var taxonomy = $(this).attr('data-taxonomy');
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var data = {
					'action': 'ova_megamenu_filter_custom_taxonomies',
					'name': name,
					'taxonomy': taxonomy,
				};
				$.post(ova_megamenu.ajax_url,data,function(res){
					this_item.find('.list-terms').html('');
					this_item.find('.list-terms').html(res);
				});
			});
		}

		ova_megamenu_filter_custom_post_type(){
			var that = this;
			$(document).on('change','.ova_megamenu_accordion_item input.filter_custom_post_type',function(){
				var title = $(this).val();
				var post_type = $(this).attr('data-post-type');
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var data = {
					'action': 'ova_megamenu_filter_custom_post_type',
					'title': title,
					'post_type': post_type,
				};
				$.post(ova_megamenu.ajax_url,data,function(res){
					this_item.find('.list-custom-post-type').html('');
					this_item.find('.list-custom-post-type').html(res);
				});
			});
		}

		ova_megamenu_add_custom_post_item(){
			$(document).on('click','.ova_megamenu_add_custom_post_item',function(e){
				e.preventDefault();
				var inputs = $(document).find('.ova_megamenu_accordion .list-custom-post-type input[type="checkbox"]:checked');
				var post_ids = [];
				var row = $(this).attr('data-row');
				var column = $(this).attr('data-column');
				var widget = $(this).attr('data-widget');
				var menu_item = $(this).attr('data-menu-item');
				var this_item = $(this).closest('.ova_megamenu_accordion_item');
				var this_tab = $(this).attr('data-tab');
				inputs.each(function(i,el){
					let post_id = $(el).val();
					post_ids.push( post_id );
					$(el).prop( "checked", false );
				});
				this_item.find('.check_all_item').prop( "checked", false );
				var data = {
					'action': 'ova_megamenu_add_custom_post_item',
					'post_ids': post_ids,
					'row': row,
					'column': column,
					'widget': widget,
					'menu_item': menu_item,
					'this_tab': this_tab,
				};

				$.post(ova_megamenu.ajax_url,data,function(res){
					var that_item = $(document).find('.tabs-content[data-tab="'+this_tab+'"] .ova_megamenu_widget_item[data-row="'+row+'"][data-column="'+column+'"][data-widget="'+widget+'"]');
					that_item.find('.list-menu-item').append(res);
					var count_menu_item = that_item.find('.list-menu-item .menu-item').length;
					that_item.find('.ova_megamenu_add_menu_item').attr('data-menu-item',count_menu_item);
					$(document).find('.ova_megamenu_add_to_menu').attr('data-menu-item',count_menu_item);
					if ( count_menu_item ) {
						that_item.find('.ova_megamenu_menu_item_bulk_select').addClass('is-active');
					} else {
						that_item.find('.ova_megamenu_menu_item_bulk_select').removeClass('is-active');
					}
				});
			});
		}

	}

	new OVAM_Admin();

})(jQuery);