(function($) {
	$.fn.ova_right = function() {
		return $(document).width() - (this.offset().left + this.outerWidth());
	}
	$.fn.ova_get_hidden_offset_width = function () {
	    // save a reference to a cloned element that can be measured
	    var $hiddenElement = $(this).clone().appendTo('body');

	    // calculate the width of the clone
	    var width = $hiddenElement.outerWidth();

	    // remove the clone from the DOM
	    $hiddenElement.remove();

	    return width;
	};
	class OVAM_Frontend {

		constructor(){
			this.ova_megamenu_active();
			this.ova_megamenu_window_resize();
		}
		
		ova_megamenu_active(){
			var that = this;
			if ( $('.ova-megamenu-item').length ) {

				var ova_megamenu_container = $('.ova-megamenu-item').find('.ova_megamenu_container');
				var action_hide_menu = ova_megamenu_container.attr('data-action-hide');

				var desktop_max_width = parseFloat( ova_megamenu_container.attr('data-desktop-max-width') );
				var tablet_max_width = parseFloat( ova_megamenu_container.attr('data-tablet-max-width') );
				var mobile_max_width = parseFloat( ova_megamenu_container.attr('data-mobile-max-width') );

				var tablet_from = parseFloat( ova_megamenu_container.attr('data-tablet-from') );
				var tablet_to = parseFloat( ova_megamenu_container.attr('data-tablet-to') );

				var mobile_from = parseFloat( ova_megamenu_container.attr('data-mobile-from') );
				var mobile_to = parseFloat( ova_megamenu_container.attr('data-mobile-to') );

				var tablet_display = ova_megamenu_container.attr('data-tablet-display');
				// Init Menu
				that.ova_megamenu_init();

				// Show menu
				$('.ova-megamenu-item').on('click mouseenter touchstart',function(e){
					e.stopPropagation();
					var target = e.target;

					if ( ( ! $('.ova_megamenu_container').is( $(target) ) && $('.ova_megamenu_container').has( $(target) ).length === 0 ) ) {
						
						var ova_megamenu_actived = $('.ova-megamenu-item.ova-megamenu-active');
						var document_width = $(document).width();
						var offset = $(this)[0].getBoundingClientRect();
						var offset_top = offset.top;
						var offset_left = offset.left;
						var offset_right = $(this).ova_right();
						var inner_height = $(this).innerHeight();
						var offset_Ox = offset_left + ( $(this).width() / 2 );
						var ova_megamenu_container = $(this).find('.ova_megamenu_container');
						var ova_megamenu = ova_megamenu_container.find('.ova_megamenu.is-active');
						var width_style = ova_megamenu_container.attr('data-width-style');
						var position = ova_megamenu_container.attr('data-position');
						
						// check menu is active
						if ( ! $(this).hasClass('ova-megamenu-active') ) {

							// hide menus
							if ( ova_megamenu_actived.length ) {
								ova_megamenu_actived.each( function(i,el){
									$(el).removeClass('ova-megamenu-active');
									var ova_megamenu_container = $(el).find('.ova_megamenu_container');
									var ova_megamenu = ova_megamenu_container.find('.ova_megamenu.is-active');
									var offset = $(el)[0].getBoundingClientRect();
									var offset_top = offset.top;
									var inner_height = $(el).innerHeight();
									var menu_type = ova_megamenu.attr('data-menu');
									var check_display_mobile = false;

									if ( menu_type == 'mobile' ) {
										check_display_mobile = true;
									}

									if ( menu_type == 'tablet' && tablet_display == 'mobile' ) {
										check_display_mobile = true;
									}

									if ( check_display_mobile == false ) {
										var style = {
											'position': 'relative',
											'opacity': 0,
											'top': offset_top + inner_height + 50,
										};

										ova_megamenu_container.animate( style, 160, 'linear', function(){
											ova_megamenu_container.fadeOut();
										} );
									} else {
										ova_megamenu_container.fadeOut();
									}
								} );
							}

							$(this).addClass('ova-megamenu-active');

							// check current menu
							ova_megamenu_container.find('.ova_megamenu').removeClass('is-active');

							if ( ! isNaN( mobile_from ) && ! isNaN( mobile_to ) && document_width >= mobile_from && document_width <= mobile_to ) {
								ova_megamenu_container.find('.ova_megamenu[data-menu="mobile"]').addClass('is-active');
								ova_megamenu = ova_megamenu_container.find('.ova_megamenu[data-menu="mobile"]');
							} else if ( ! isNaN( tablet_from ) && ! isNaN( tablet_to ) && document_width >= tablet_from && document_width <= tablet_to ){
								ova_megamenu_container.find('.ova_megamenu[data-menu="tablet"]').addClass('is-active');
								ova_megamenu = ova_megamenu_container.find('.ova_megamenu[data-menu="tablet"]');
							} else {
								ova_megamenu_container.find('.ova_megamenu[data-menu="desktop"]').addClass('is-active');
							}

							var ova_megamenu_container_width = ova_megamenu_container.ova_get_hidden_offset_width();

							var menu_type = ova_megamenu.attr('data-menu');

							if ( width_style == 'container' ) {

								switch( menu_type ) {
									case 'desktop':
										if ( ! isNaN( desktop_max_width ) && desktop_max_width > 0 ) {
											ova_megamenu_container_width = desktop_max_width;
										}
									break;
									case 'tablet':
										if ( ! isNaN( tablet_max_width ) && tablet_max_width > 0 ) {
											ova_megamenu_container_width = desktop_max_width;
										}
									break;
									case 'mobile':
										if ( ! isNaN( mobile_max_width ) && mobile_max_width > 0 ) {
											ova_megamenu_container_width = desktop_max_width;
										}
									break;
									default:

								}
							}

							var offset_left_center = offset_Ox - ( ova_megamenu_container_width / 2 );
							if ( offset_left_center < 0 ) {
								offset_left_center = 0;
							}
							if ( offset_right < 0 ) {
								offset_right = 0;
							}

							
							var check_display_mobile = false;

							if ( menu_type == 'mobile' ) {
								check_display_mobile = true;
							}

							if ( menu_type == 'tablet' && tablet_display == 'mobile' ) {
								check_display_mobile = true;
							}

							if ( check_display_mobile == false ) {
								// desktop , tablet menu
								
								var style_default = {
									'display': 'block',
									'position': 'fixed',
									'opacity': 0,
								};

								var style_position = {};

								if ( width_style == 'container' ) {

									switch( position ) {
										case 'left':
											if ( ( offset_left + ova_megamenu_container_width ) > document_width ) {
												style_position = {
													'right': '0',
													'left': 'auto',
												};
											} else {
												style_position = {
													'left': offset_left,
													'right': 'auto',
												};
											}
										break;
										case 'right':
											if ( ( offset_right + ova_megamenu_container_width ) > document_width ) {
												style_position = {
													'left': '0',
													'right': 'auto',
												};
											} else {
												style_position = {
													'left': 'auto',
													'right': offset_right,
												};
											}
										break;
										case 'center':
											if ( ( offset_left_center + ova_megamenu_container_width ) > document_width ) {
												if ( offset_left - offset_right > 0 ) {
													style_position = {
														'left': 'auto',
														'right': '0',
													};
												} else {
													style_position = {
														'left': '0',
														'right': 'auto',
													};
												}
											} else {
												style_position = {
													'left': offset_left_center,
													'right': 'auto',
												};
											}
										break;
										default:
										}
								} else {
									style_position = {
										'left': '0',
										'width': '100%',
										'max-width': '100%',
									};
								}

								var style = {...style_default,...style_position};
								ova_megamenu_container.css( style );

								ova_megamenu_container.animate( { 'top': offset_top + inner_height, 'opacity': 1 } );

							} else {
								// mobile menu
								ova_megamenu_container.css( {'opacity': 1,'position': 'relative','width': '100%','top': 0,'left': 0 } );
								ova_megamenu_container.fadeIn();
							}

							return false;

						} else {

							$(this).removeClass('ova-megamenu-active');

							var menu_type = ova_megamenu.attr('data-menu');
							var check_display_mobile = false;

							if ( menu_type == 'mobile' ) {
								check_display_mobile = true;
							}

							if ( menu_type == 'tablet' && tablet_display == 'mobile' ) {
								check_display_mobile = true;
							}

							if ( check_display_mobile == false ) {
								var style = {
									'position': 'relative',
									'opacity': 0,
									'top': offset_top + inner_height + 50,
								};

								ova_megamenu_container.animate( style, 160, 'linear', function(){
									ova_megamenu_container.fadeOut();
								} );
							} else {
								ova_megamenu_container.fadeOut();
							}
							return false;
							
						}

					}
					
				});

				
				$(document).on('click',function(e){
					var ova_megamenu_item = $('.ova-megamenu-item.ova-megamenu-active');
					if ( ova_megamenu_item.length ) {
						var ova_megamenu_container = $('.ova_megamenu_container');
						var ova_megamenu = ova_megamenu_container.find('.ova_megamenu.is-active');
						var menu_type = ova_megamenu.attr('data-menu');
						var offset = ova_megamenu_item.offset();
						var offset_top = offset.top;
						var offset_left = offset.left;
						var offset_right = ova_megamenu_item.ova_right();
						var inner_height = ova_megamenu_item.innerHeight();
						var check_display_mobile = false;
						if ( menu_type == 'mobile' ) {
							check_display_mobile = true;
						}
						if ( menu_type == 'tablet' && tablet_display == 'mobile' ) {
							check_display_mobile = true;
						}

						if ( ! ova_megamenu_item.is(e.target) && ova_megamenu_item.has(e.target).length === 0 && ! ova_megamenu_container.is(e.target) && ova_megamenu_container.has(e.target).length === 0 ){

							ova_megamenu_item.removeClass('ova-megamenu-active');
							if ( check_display_mobile == false ) {
								var style = {
									'position': 'relative',
									'opacity': 0,
									'top': offset_top + inner_height + 50,
								};

								ova_megamenu_container.animate( style, 160, 'linear', function(){
									ova_megamenu_container.fadeOut();
								} );
							} else {
								ova_megamenu_container.fadeOut();
							}

					    }
					}
					
				});

				if ( action_hide_menu == 'mouseleave' ) {
					$('.ova-megamenu-item').on('mouseleave',function(){
						var $this = $(this);
						var ova_megamenu_item = $('.ova-megamenu-item.ova-megamenu-active');
						if ( ova_megamenu_item.length ) {
							var ova_megamenu_container = $this.find('.ova_megamenu_container');
							var ova_megamenu = ova_megamenu_container.find('.ova_megamenu.is-active');
							var menu_type = ova_megamenu.attr('data-menu');
							var offset = ova_megamenu_item.offset();
							var offset_top = offset.top;
							var offset_left = offset.left;
							var offset_right = ova_megamenu_item.ova_right();
							var inner_height = ova_megamenu_item.innerHeight();
							var check_display_mobile = false;
							if ( menu_type == 'mobile' ) {
								check_display_mobile = true;
							}
							if ( menu_type == 'tablet' && tablet_display == 'mobile' ) {
								check_display_mobile = true;
							}

							ova_megamenu_item.removeClass('ova-megamenu-active');

							if ( check_display_mobile == false ) {
								var style = {
									'position': 'relative',
									'opacity': 0,
									'top': offset_top + inner_height + 50,
								};

								ova_megamenu_container.animate( style, 160, 'linear', function(){
									ova_megamenu_container.fadeOut();
								} );
							} else {
								ova_megamenu_container.fadeOut();
							}
						}
						
					});
				}
				
			}
		}


		ova_megamenu_window_resize(){
			var that = this;
			$(window).on('resize',function(){
				that.ova_megamenu_init();
			});
		}

		ova_megamenu_init(){
			if ( $('.ova-megamenu-item').length ) {
				var ova_megamenu_container = $('.ova-megamenu-item').find('.ova_megamenu_container');

				var desktop_max_width = parseFloat( ova_megamenu_container.attr('data-desktop-max-width') );
				var tablet_max_width = parseFloat( ova_megamenu_container.attr('data-tablet-max-width') );
				var mobile_max_width = parseFloat( ova_megamenu_container.attr('data-mobile-max-width') );

				var tablet_from = parseFloat( ova_megamenu_container.attr('data-tablet-from') );
				var tablet_to = parseFloat( ova_megamenu_container.attr('data-tablet-to') );

				var mobile_from = parseFloat( ova_megamenu_container.attr('data-mobile-from') );
				var mobile_to = parseFloat( ova_megamenu_container.attr('data-mobile-to') );

				var tablet_display = ova_megamenu_container.attr('data-tablet-display');

				$('.ova-megamenu-item').each( function(i,el){
					var offset = $(el).offset();
					var offset_top = offset.top;
					var offset_left = offset.left;
					var offset_right = $(el).ova_right();
					var inner_height = $(el).innerHeight();
					var ova_megamenu_container = $(el).find('.ova_megamenu_container');
					var ova_megamenu = ova_megamenu_container.find('.ova_megamenu[data-menu="desktop"]');
					var offset_Ox = offset_left + ( $(el).width() / 2 );
					
					var width_style 	= ova_megamenu_container.attr('data-width-style');
					var position 		= ova_megamenu_container.attr('data-position');
					var document_width 	= $(document).width();

					// check current menu
					if ( ! isNaN( mobile_from ) && ! isNaN( mobile_to ) && document_width >= mobile_from && document_width <= mobile_to ) {
						ova_megamenu_container.find('.ova_megamenu[data-menu="mobile"]').addClass('is-active');
						ova_megamenu = ova_megamenu_container.find('.ova_megamenu[data-menu="mobile"]');
					} else if ( ! isNaN( tablet_from ) && ! isNaN( tablet_to ) && document_width >= tablet_from && document_width <= tablet_to ){
						ova_megamenu_container.find('.ova_megamenu[data-menu="tablet"]').addClass('is-active');
						ova_megamenu = ova_megamenu_container.find('.ova_megamenu[data-menu="tablet"]');
					} else {
						ova_megamenu_container.find('.ova_megamenu[data-menu="desktop"]').addClass('is-active');
					}

	                var hide_menu = parseInt( ova_megamenu_container.attr('data-hide-menu') );
					var menu_type = ova_megamenu.attr('data-menu');

	                if ( ! isNaN( hide_menu ) && document_width <= hide_menu ) {
	                    $(el).fadeOut();
	                }

					// check width
					var ova_megamenu_container_width = ova_megamenu_container.ova_get_hidden_offset_width();

					if ( width_style == 'container' ) {

						switch( menu_type ) {
							case 'desktop':
								if ( ! isNaN( desktop_max_width ) && desktop_max_width > 0 ) {
									ova_megamenu_container_width = desktop_max_width;
								}
							break;
							case 'tablet':
								if ( ! isNaN( tablet_max_width ) && tablet_max_width > 0 ) {
									ova_megamenu_container_width = desktop_max_width;
								}
							break;
							case 'mobile':
								if ( ! isNaN( mobile_max_width ) && mobile_max_width > 0 ) {
									ova_megamenu_container_width = desktop_max_width;
								}
							break;
							default:

						}
					}

					var offset_left_center = offset_Ox - ( ova_megamenu_container_width / 2 );

					if ( offset_left_center < 0 ) {
						offset_left_center = 0;
					}

					var check_display_mobile = false;

					if ( menu_type == 'mobile' ) {
						check_display_mobile = true;
					}

					if ( menu_type == 'tablet' && tablet_display == 'mobile' ) {
						check_display_mobile = true;
					}

					// style
					if ( check_display_mobile == false ) {

						var style_default = {
							'position': 'fixed',
							'opacity': 0,
							'top': offset_top + inner_height + 50,
						};

						var style_position = {};


						if ( width_style == 'container' ) {

							switch( position ) {
								case 'left':
									if ( offset_left + ova_megamenu_container_width > document_width ) {
										style_position = {
											'right': '0',
											'left': 'auto',
										};
									} else {
										style_position = {
											'left': offset_left,
											'right': 'auto',
										};
									}
								break;
								case 'right':

									if ( offset_right + ova_megamenu_container_width > document_width ) {
										style_position = {
											'left': '0',
											'right': 'auto',
										};
									} else {
										style_position = {
											'left': 'auto',
											'right': offset_right,
										};
									}
									
								break;
								case 'center':
									if ( offset_left_center + ova_megamenu_container_width > document_width ) {
										if ( offset_left - offset_right > 0 ) {
											style_position = {
												'left': 'auto',
												'right': '0',
											};
										} else {
											style_position = {
												'left': '0',
												'right': 'auto',
											};
										}
									} else {
										style_position = {
											'left': offset_left_center,
											'right': 'auto',
										};
									}
								break;
								default:
								}
						} else {
							style_position = {
								'left': '0',
								'width': '100%',
								'max-width': '100%',
							};
						}

						var style = {...style_default,...style_position};
						ova_megamenu_container.css( style );

					} else {
						ova_megamenu_container.css( {'opacity': 1,'position': 'relative','top': 0, 'left': 0} );
					}
					
				} );
			}
		}
	}

	new OVAM_Frontend();

})(jQuery);