<?php

if ( !defined( 'ABSPATH' ) ) exit();

if ( ! class_exists('OVAM_CPT') ) {
	class OVAM_CPT {
		public function __construct(){
			add_action( 'init', array( $this, 'ova_menu_post_type' ) );
		}

		public function ova_menu_post_type(){
			
			$labels = array(
				'name'               => esc_html__( 'Mega Menu', 'ova-megamenu' ),
				'singular_name'      => esc_html__( 'Mega Menu', 'ova-megamenu' ),
				'add_new'            => _x( 'Add New Menu', 'ova-megamenu', 'ova-megamenu' ),
				'add_new_item'       => esc_html__( 'Add New Menu', 'ova-megamenu' ),
				'edit_item'          => esc_html__( 'Edit Menu', 'ova-megamenu' ),
				'new_item'           => esc_html__( 'New Menu', 'ova-megamenu' ),
				'view_item'          => esc_html__( 'View Menu', 'ova-megamenu' ),
				'search_items'       => esc_html__( 'Search Menu', 'ova-megamenu' ),
				'not_found'          => esc_html__( 'No Menu found', 'ova-megamenu' ),
				'not_found_in_trash' => esc_html__( 'No Menu found in Trash', 'ova-megamenu' ),
				'parent_item_colon'  => esc_html__( 'Parent Menu:', 'ova-megamenu' ),
				'menu_name'          => esc_html__( 'Ova Mega Menu', 'ova-megamenu' ),
			);
		
			$args = array(
				'labels'              => $labels,
				'hierarchical'        => false,
				'description'         => '',
				'taxonomies'          => array(),
				'public'              => true,
				'show_ui'             => true,
				'show_in_menu'        => true,
				'show_in_admin_bar'   => false,
				'menu_position'       => 80,
				'menu_icon'           => 'dashicons-welcome-widgets-menus',
				'show_in_nav_menus'   => false,
				'publicly_queryable'  => true,
				'exclude_from_search' => true,
				'has_archive'         => false,
				'query_var'           => true,
				'can_export'          => true,
				'rewrite'             => true,
				'capability_type'     => 'post',
				'supports'            => array(
					'title',
					'editor',
					'author',
				),
			);
		
			register_post_type( 'ova-megamenu', $args );
		}
	}

	new OVAM_CPT();
}