<?php

if ( ! defined('ABSPATH') ) {
	exit();
}

if ( ! class_exists( 'OVAM_Google_Fonts' ) ) {
	
	class OVAM_Google_Fonts {

		private $font_list = [];

		public function __construct(){
			$font_orderby = ova_megamenu_google_font_orderby();
			$count = ova_megamenu_google_font_count();
			$this->font_list = $this->get_google_fonts( $count, $font_orderby );
		}

		public function get_font_list_family(){
			$font_list = $this->font_list;
			$font_family = array();
			if ( ! empty( $font_list ) ) {
				foreach ( $font_list as $key => $val ) {
					$font_family[] = $val->family;
				}
			}

			return $font_family;
		}

		public function get_font_index( $haystack, $needle ) {
			foreach( $haystack as $key => $value ) {
				if( $value->family == $needle ) {
					return $key;
				}
			}
			return '';
		}

		public function get_google_fonts( $count = 'all', $font_orderby = 'popular' ){

			$fontFile = OVA_MEGAMENU_PLUGIN_URI.'assets/fonts/google-fonts-popularity.json';

			if ( $font_orderby == 'alpha' ) {
				$fontFile = OVA_MEGAMENU_PLUGIN_URI.'assets/fonts/google-fonts-alphabetical.json';
			}
			
			$request = wp_remote_get( $fontFile );

			if( is_wp_error( $request ) ) {
				return "";
			}

			$body = wp_remote_retrieve_body( $request );
			$content = json_decode( $body );

			if( $count == 'all' ) {
				return $content->items;
			} else {
				return array_slice( $content->items, 0, (int)$count );
			}
		}

		public function get_font_weight( $font_family ){
			$font_list = $this->font_list;
			$index = $this->get_font_index( $font_list, $font_family );
			$font_weight = $font_list[$index]->variants;
			return $font_weight;
		}

		public function get_font_src( $font_family, $font_weight ){
			if ( empty( $font_family ) || empty( $font_weight ) ) {
				return '';
			}
			$font_list = $this->font_list;
			$index = $this->get_font_index( $font_list, $font_family );
			$files = (array)$font_list[$index]->files;
			$font_src = '';
			if ( isset( $files[$font_weight] ) ) {
				$font_src = $files[$font_weight];
			}
			return $font_src;
		}

	}
}