<?php

if ( !defined( 'ABSPATH' ) ) exit();

if ( ! class_exists('OVAM_Assets') ) {
	class OVAM_Assets {

		protected $css_setting;

		public function __construct(){
			$this->css_setting = OVAM_Css_Print::instance()->get_css_setting();

			add_action( 'admin_enqueue_scripts', array( $this, 'load_admin_scripts' ) );
			add_action( 'wp_enqueue_scripts', array( $this, 'load_frontend_scripts' ), 100 );
			add_action( 'wp_head', array( $this, 'load_menu_style' ) );
		}

		public function load_admin_scripts(){



			wp_enqueue_style( 'zebra-dialog', OVA_MEGAMENU_PLUGIN_URI.'assets/libs/zebra-dialog/css/classic/zebra_dialog.min.css', 'all' );
			wp_enqueue_script('zebra-dialog', OVA_MEGAMENU_PLUGIN_URI .'assets/libs/zebra-dialog/zebra_dialog.min.js', array('jquery'), false, true);
			
			wp_enqueue_script( 'jquery-resizable', OVA_MEGAMENU_PLUGIN_URI.'assets/libs/jquery-resizable.min.js',array('jquery'), false, true);

			wp_enqueue_style( 'ova_megamenu_select2', OVA_MEGAMENU_PLUGIN_URI.'assets/libs/select2/css/select2.min.css', 'all' );
            wp_enqueue_script('ova_megamenu_select2', OVA_MEGAMENU_PLUGIN_URI.'assets/libs/select2/js/select2.min.js', array('jquery'), false, true);

			wp_enqueue_style( 'ova-megamenu-admin', OVA_MEGAMENU_PLUGIN_URI.'assets/css/admin/admin.css', 'all' );
			
			wp_enqueue_script('ova-megamenu-admin', OVA_MEGAMENU_PLUGIN_URI.'assets/js/admin/admin.js', array('jquery'), false, true);
			wp_localize_script( 'ova-megamenu-admin', 'ova_megamenu', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		}

		public function load_frontend_scripts(){
			wp_enqueue_style( 'ova-megamenu-vendor', OVA_MEGAMENU_PLUGIN_URI.'assets/css/frontend/vendor.css', 'all' );

			wp_enqueue_style( 'ova-megamenu-frontend', OVA_MEGAMENU_PLUGIN_URI.'assets/css/frontend/frontend.css', 'all' );
			wp_enqueue_script('ova-megamenu-frontend', OVA_MEGAMENU_PLUGIN_URI.'assets/js/frontend/frontend.js', array('jquery'), false, true);

			if ( $this->css_setting == 'external' ) {
				if ( file_exists( trailingslashit( wp_upload_dir()['basedir'] ).'ova-megamenu-style.css' ) ) {
					wp_enqueue_style( 'ova-megamenu-style', trailingslashit( wp_upload_dir()['baseurl'] ).'ova-megamenu-style.css', 'all' );
				}
			}
		}

		public function load_menu_style(){
			if ( $this->css_setting != 'external' ) {
				OVAM_Css_Print::instance()->print_css();
			} else {
				// check file not exist
				if ( ! file_exists( trailingslashit( wp_upload_dir()['basedir'] ).'ova-megamenu-style.css' ) ) {
					OVAM_Css_Print::instance()->print_css();
				}
			}
		}
	}

	new OVAM_Assets();
}