<?php

if ( !defined( 'ABSPATH' ) ) exit();

if ( ! class_exists( 'OVAM_Hooks' ) ) {
	
	class OVAM_Hooks {

		public function __construct(){
			add_filter( 'nav_menu_css_class', array( $this, 'add_ova_megamenu_class' ), 10, 3 );

			add_filter( 'walker_nav_menu_start_el', array( $this, 'add_ova_megamenu' ), 10, 4 );

			add_action( 'update_option_ova_megamenu', array( $this, 'save_file_css' ) );
		}

		public function add_ova_megamenu_class( $classes, $menu_item, $args ){
			if ( is_object( $menu_item ) && isset( $menu_item->ID ) ) {
				$shortcode = get_post_meta( $menu_item->ID, '_menu_item_shortcode', true );
				if ( ! empty( $shortcode ) ) {
					$classes = array_merge( $classes, array('ova-megamenu-item') );
				}
			}

			return apply_filters( 'ova_menu_submenu_css_class', $classes, $menu_item, $args );
		}

		public function add_ova_megamenu( $item_output, $menu_item, $depth, $args ){

			if ( is_object( $menu_item ) && isset( $menu_item->ID ) ) {
				$shortcode = get_post_meta( $menu_item->ID, '_menu_item_shortcode', true );
				if ( ! empty( $shortcode ) && $depth < 1 ) {
					$item_output .= do_shortcode( $shortcode );
				}
			}

			return apply_filters( 'ova_walker_nav_menu_start_el', $item_output, $menu_item, $depth, $args );
		}

		public function save_file_css(){
			$css_content = OVAM_Css_Print::instance()->get_setting_css();
			$css_file = trailingslashit( wp_upload_dir()['basedir'] ).'ova-megamenu-style.css';
			file_put_contents($css_file, $css_content);
		}
	}

	new OVAM_Hooks();
}